#define F_CPU 16000000UL // บอกไลบรารีว่า MCU ทำงานที่ 16MHz
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit)) // clear bit
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit)) // set bit
#define tog(sfr, bit) (_SFR_BYTE(sfr) ^= _BV(bit)) // toggle bi
#define interval 0.368
float dl_ms=0,dl_s=0;
float count_ms=0,count_s=0;



char in_c(char pin)
{
    // read logic level of port-C's pin
    DDRC &= ~(1<<pin);
    return ((PINC & (1<<pin))>>pin);    
} 

void out_c(char pin, char val)
{
    // write logic level to port-C's pin
    DDRC |= 1<<pin;
    if(val)
        PORTC |= 1<<pin;
    else
        PORTC &= ~(1<<pin);
}

/*ISR(TIMER0_OVF_vect) {
	
	_delay_ms(0.7);
}*/
// This interrupt service routine is for the channel connected to PC5
ISR(PCINT1_vect)
{
	if(PINC & (1<<5)){
		if(dl_ms >= 11.05) dl_ms=0;
		if(dl_s>=11.05) dl_s=0;
		out_c(1,1);
        _delay_ms(dl_s);
        out_c(1,0);
        out_c(2,1);
        _delay_ms(dl_ms-dl_s);
        out_c(2,0);
       
        
					
		count_ms = count_ms + 11.050;
		if(count_ms >= 16.67) 
		{	
			count_ms=0;	
			dl_ms = dl_ms + 0.185;
		}

		count_s = count_s + 11.050;
		if(count_s >= 1000) 
		{	
			count_s=0;	
			dl_s = dl_s + 0.185;
		}
    
       _delay_ms(11.05-dl_ms);
		


		
		
	}
	
}

int main(void)
{
		
	DDRC |= 0b00000111;
	PORTC |= (1<<5);

	PCMSK1 |= (1<<PCINT13);
	PCICR |= (1<<PCIE1);

	sei();

	while(1){;}		    
}

